-- Test edit_surroundings_highlight
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(12);

set search_path to camper, public;

select has_function('camper', 'edit_surroundings_highlight', array['integer', 'integer', 'text', 'text']);
select function_lang_is('camper', 'edit_surroundings_highlight', array['integer', 'integer', 'text', 'text'], 'sql');
select function_returns('camper', 'edit_surroundings_highlight', array['integer', 'integer', 'text', 'text'], 'integer');
select isnt_definer('camper', 'edit_surroundings_highlight', array['integer', 'integer', 'text', 'text']);
select volatility_is('camper', 'edit_surroundings_highlight', array['integer', 'integer', 'text', 'text'], 'volatile');
select function_privs_are('camper', 'edit_surroundings_highlight', array ['integer', 'integer', 'text', 'text'], 'guest', array[]::text[]);
select function_privs_are('camper', 'edit_surroundings_highlight', array ['integer', 'integer', 'text', 'text'], 'employee', array[]::text[]);
select function_privs_are('camper', 'edit_surroundings_highlight', array ['integer', 'integer', 'text', 'text'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'edit_surroundings_highlight', array ['integer', 'integer', 'text', 'text'], 'authenticator', array[]::text[]);


set client_min_messages to warning;
truncate surroundings_highlight cascade;
truncate media cascade;
truncate media_content cascade;
truncate company cascade;
reset client_min_messages;


insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
;

insert into media_content (media_type, bytes)
values ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffffff","a"};')
     , ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ff00ff","a"};')
     , ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffff00","a"};')
;

insert into media (media_id, company_id, original_filename, content_hash)
values (2, 1, 'cover2.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffffff","a"};'))
     , (3, 1, 'cover3.xpm', sha256('static char *s[]={"1 1 1 1","a c #ff00ff","a"};'))
     , (4, 1, 'cover4.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffff00","a"};'))
;

insert into surroundings_highlight (surroundings_highlight_id, company_id, media_id, name, description)
values (8, 1, 2, 'Highlight A', '<h1>1</h1>')
     , (9, 1, 3, 'Highlight B', '<h2>2</h2>')
;

select lives_ok(
	$$ select edit_surroundings_highlight(8, 4, 'Highlight 1', '<h3>A</h3>') $$,
	'Should be able to edit the first highlight'
);

select lives_ok(
	$$ select edit_surroundings_highlight(9, null, 'Highlight 2', '<h1>B</h1>') $$,
	'Should be able to edit the second highlight'
);

select bag_eq(
	$$ select surroundings_highlight_id, media_id, name, description::text from surroundings_highlight $$,
	$$ values (8, 4, 'Highlight 1', '<h3>A</h3>')
	        , (9, 3, 'Highlight 2', '<h1>B</h1>')
	$$,
	'Should have updated all surroundings highlights.'
);


select *
from finish();

rollback;
